/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Mar 24, 2005
 *
 */
package com.sunlabs.archsim.tests.branch;

import com.sunlabs.archsim.base.hierarchy.CompositeEntity;
import com.sunlabs.archsim.fleet.common.Data;
import com.sunlabs.archsim.fleet.common.Payload;
import com.sunlabs.archsim.gasp.BranchAction;
;

/**
 * @author ib27688
 *
 */
public class TestBranchAction extends BranchAction {
	
	public TestBranchAction(String name, int numBranches) {
		super(name, numBranches);
	}
	
	public TestBranchAction(String name, int numBranches, CompositeEntity g) {
		super(name, numBranches, g);
	}	
	
	/** data value modulo number of branches */
	public int selectBranch(Object data) {
		int selection= 0;
		if (data instanceof Integer) {
			selection= ((Integer)data).intValue() % numBranches;
		}
		else if (data instanceof Data) {
			Data d= (Data)data;
			if (d.valid && d.value instanceof Integer) {
				selection= ((Integer)d.value).intValue() % numBranches;				
			}
		}
		else if (data instanceof Payload) {
			Data d= ((Payload)data).data;
			if (d.valid && d.value instanceof Integer) {
				selection= ((Integer)d.value).intValue() % numBranches;				
			}			
		}
		return selection;
	}

} // TestBranchAction
